﻿using System;
using System.Windows.Forms;

namespace ServiceHelper
{
    public partial class Settings : Form
    {
        private string _configFilePath = "service.config";
        public ManagerXml _managerXml; 

        public Settings()
        {
            InitializeComponent();

            _managerXml = new ManagerXml(_configFilePath);

            //读取任务计划配置
            checkBoxUseTask.Checked = _managerXml.Get("UseTask") == "true" ? true : false;
            textBoxDaysInterval.Text = _managerXml.Get("TaskDaysInterval");
            maskedTextBoxStartBoundary.Text = _managerXml.Get("TaskStartBoundary");
        }

        private void OkBtn_Click(object sender, EventArgs e)
        {
            try
            {
                //写入计划任务
                _managerXml.Set("UseTask",checkBoxUseTask.Checked?"true":"false");
                _managerXml.Set("TaskDaysInterval",textBoxDaysInterval.Text);
                _managerXml.Set("TaskStartBoundary",maskedTextBoxStartBoundary.Text);
                if (checkBoxUseTask.Checked)
                {
                    bool taskSeted = TaskControl.SetTask(short.Parse(textBoxDaysInterval.Text),maskedTextBoxStartBoundary.Text);
                    if (!taskSeted)
                    {
                        MessageBox.Show("计划任务添加失败");
                    }
                }
                else {
                    TaskControl.DeleteTestTask();
                }

                this.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "保存配置文件错误", MessageBoxButtons.OK);
            }
        }

        private void CancleBtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
